{ Projet de TP MIA09 / 2000 }
{ Antoine JACQUET / Sbastien LERICHE}
{ Section MH groupe 2 tp 1}
program TALK;
uses com_4,crt,dos;             {librairies TP}
const FICHIER_INI='talk.ini';   {fichier des paramtres modem+utilisateurs}
      MAX_LIGNES=500;           {nombre de lignes du buffer}
      MAX_BUFFER=510;           {taille relle du buffer (car fentre=10 lignes)}

type Tbuffer=array[1..MAX_BUFFER] of string[78];  {buffer de texte=tableau de string}
     Pfenetre=^Tfenetre;
     Tfenetre=record              {type des fentres emission/reception}
       buffer:Tbuffer;
       ligne:word;                {ligne en cours (scrolling)}
       x_curs,y_curs:word;        {position du curseur}
       x1,y1,x2,y2:byte;          {position de la fenetre}
       ctext,cback:byte;          {couleurs texte+fond}
     end;

var com:porttype;               {port de communication  utiliser}
    quitte:boolean;
    haut,bas:Pfenetre;          {fentres emission/reception}
    connecte:boolean;           {variable d'tat de connection}
    login,temps:string;         {utilisateur et heure en cours}
    user:record                 {parametres modifiables lus dans talk.ini}
      nom:string;               {-> cf. doc fichier INI}
      t_menu,b_menu,
      t_bordure,b_bordure,
      t_titre_emission,b_titre_emission,
      t_titre_reception,b_titre_reception,
      t_popup,b_popup:byte;
      titre_emission,titre_reception:string;
    end;

function ntouche:word;
{rcupre le code ASCII d'une touche de la manire suivante :}
{ntouche=code ascii si NON ETENDU}
{ntouche=1000+code ascii si ETENDU}
var c:char;
begin
  c:=readkey;
  if c=#0 then begin  {#0 => caractre tendu  suivre}
    c:=readkey;
    ntouche:=1000+ord(c);
  end else ntouche:=ord(c);
end;

function upstring(s:string):string;
{conversion de chaine minuscules -> majuscules}
var i:byte;
    aux:string;
begin
  aux:='';
  for i:=1 to length(s) do aux:=aux+upcase(s[i]);
  upstring:=aux;
end;

function popup_confirm(msg:string):boolean;
{fentre popup demande confirmation pour 'msg'}
{renvoie true/ENTREE & false/ESC}
var c:char;
begin
  window(20,10,60,14);
  textbackground(user.b_popup);
  textcolor(user.t_popup);
  clrscr;
  write('Ŀ');
  write('       Etes-vous sr de vouloir        ');
  write(''); write(msg:23); write(' ?              ');
  write('');
  write('ENTREE pour confirmer / ESC pour annuler');
  repeat  {attente d'une touche}
    c:=readkey;
  until c in [#13,#27];   {#13=entre #27=esc}
  popup_confirm:=c=#13;
end;

function popup_param(titre,msg:string; var param:string):boolean;
{fenetre popup demande parmetre 'param'; 'msg' est l'invite (prompt)}
{renvoie true/ENTREE & false/ESC}
var c:char;
begin
  param:='';
  window(20,10,60,15);
  textbackground(user.b_popup);
  textcolor(user.t_popup);
  clrscr;
  write('Ŀ');
  write(''); write(titre:24); write('':16);
  write(''); write(msg:21); write('':19);
  write('                                       ');
  write('');
  write('ENTREE pour confirmer / ESC pour annuler');
  window(25,13,55,13);
  textbackground(black);
  textcolor(lightgray);
  clrscr;
  repeat  {attente d'une touche}
    c:=readkey;
    if c=#8 then begin   {gestion du backspace}
      write(#8#0#8);
      delete(param,length(param),1);
    end else if length(param)<30 then begin {longueur max=30 car.}
      write(c);
      param:=param+c;
    end;
  until c in [#13,#27];  {#13=entre #27=esc}
  delete(param,length(param),1);
  popup_param:=c=#13;
end;

procedure popup_aide;
{fentre affichant un message d'aide (touche F1)}
var c:char;
begin
  window(20,9,61,18);
  textbackground(user.b_popup);
  textcolor(user.t_popup);
  clrscr;
  write('Ŀ');
  write('              TALK v1.0              ');
  write('Ĵ');
  write('       Un programme ralis par :       ');
  write('  Antoine JACQUET et Sbastien LERICHE  ');
  write('                                        ');
  write(' Consultez la documentation utilisateur ');
  write(' pour toute information.                ');
  write('');
  write('   Appuyez sur ENTREE pour continuer...');
  repeat  {attente d'une touche}
    c:=readkey;
  until c=#13; {#13=entre}
end;

function date_heure:string;
{renvoie une chaine de caractres contenant la date+heure au format}
{   [jj/mm/aaaa hh:mm:ss]   en formatant correctement les '0'}
var y,m,d,w:word;
    h,mi,s,c:word;

  function tostr(n:word):string;
  {passe un nombre en chaine, ajoute un '0' devant si n<10}
  var s:string;
  begin
    str(n,s);
    if n<10 then s:='0'+s;
    tostr:=s;
  end;

begin
  getdate(y,m,d,w);
  gettime(h,mi,s,c);
  {formatage de la date+heure}
  date_heure:=tostr(d)+'/'+tostr(m)+'/'+tostr(y)+' '+tostr(h)+':'+tostr(mi)+':'+tostr(s);
end;

function lire_config(section,variable:string; var valeur:string):boolean;
{cherche dans le fichier de config le paramtre 'variable' dans la section}
{'section'. Renvoie true si paramtre trouv, ne modifie pas 'valeur' si pas}
{trouv}
var fic:text;
    ligne:string;
begin
  assign(fic,FICHIER_INI);    {ouverture du fichier de config}
  reset(fic);
  if ioresult<>0 then begin   {fichier non trouv ?}
    lire_config:=false;
    exit;
  end;
  {recherche de la section}
  ligne:='';
  while (not eof(fic)) and (pos('['+section+']',ligne)<>1) do readln(fic,ligne);
  if eof(fic) then begin
    lire_config:=false;
    close(fic);
    exit;
  end;
  {recherche de la ligne}
  ligne:='';
  while (not eof(fic)) and (pos('[',ligne)<>1) and (pos(variable+'=',ligne)<>1) do
    readln(fic,ligne);
  if pos(variable+'=',ligne)=1 then begin
    valeur:=copy(ligne,pos('=',ligne)+1,length(ligne)-pos('=',ligne));
    lire_config:=true;
  end else lire_config:=false;
  close(fic);
end;

function lire_config_num(section,variable:string; var valeur:byte):boolean;
{cherche dans le fichier de config le paramtre 'variable' de type entier
dans la section 'section'. Renvoie true si paramtre trouv,
{ne modifie pas 'valeur' si pas trouv}
var temp:string;
    code:integer;
begin
  lire_config_num:=false;
  if lire_config(section,variable,temp) then begin
    val(temp,valeur,code);
    lire_config_num:=code=0;
  end;
end;

procedure close;
{fermeture du programme : libration pointeurs+modem+ param cran}
begin
  dispose(haut);        {mmoire}
  dispose(bas);
  breakcom(com);        {modem}
  exitcom(com);
  window(1,1,80,25);    {cran}
  textbackground(black);
  textcolor(lightgray);
  clrscr;
end;

procedure erreur(message:string);
{termine le programme avec un message d'erreur}
{restaure l'affichage}
begin
  close;
  writeln('Erreur : ',message,'.');
  writeln('Arrt du programme.');
  halt;
end;

procedure init_modem;
{initialisation du modem en utilisant les paramtres du fichier de configuration}
{les convertions de type sont faites via des tableaux en constantes}
{le programme gnre un message d'erreur et se termine si un paramtre est}
{invalide ou non trouv, en indiquant sa nature}
var car:char;
const s2com:array [porttype] of string[4]=('COM1','COM2','COM3','COM4');
      s2vitesse:array [baudtype] of string[6]=
      ('110','150','300','600','1200','2400','4800','9600','19200','38400','57600','115200');
      s2parite:array [paritytype] of string[5]=('NONE','ODD','EVEN','MARK','SPACE');
      s2longueur:array [lengthtype] of char=('5','6','7','8');
      s2stop:array [stoptype] of char=('1','2');
      s2controle:array [flowtype] of string[7]=('NO','RTSCTS','XONXOFF');
var vitesse:baudtype;
    parite:paritytype;
    longueur:lengthtype;
    stop:stoptype;
    controle:flowtype;
    s:string;
begin
  if not lire_config('modem','port',s) then erreur('Port non trouv');
  s:=upstring(s);
  com:=com1;
  while (s2com[com]<>s) do begin
    if com=com4 then erreur('Port non valide');
    com:=succ(com);
  end;
  if not lire_config('modem','vitesse',s) then erreur('Vitesse non trouve');
  s:=upstring(s);
  vitesse:=b110;
  while (s2vitesse[vitesse]<>s) do begin
    if vitesse=b115200 then erreur('Vitesse non valide');
    vitesse:=succ(vitesse);
  end;
  if not lire_config('modem','parite',s) then erreur('Parit non trouve');
  s:=upstring(s);
  parite:=none;
  while (s2parite[parite]<>s) do begin
    if parite=space then erreur('Parit non valide');
    parite:=succ(parite);
  end;
  if not lire_config('modem','longueur',s) then erreur('Longueur non trouve');
  s:=upstring(s);
  longueur:=D5;
  while (s2longueur[longueur]<>s) do begin
    if longueur=D8 then erreur('Longueur non valide');
    longueur:=succ(longueur);
  end;
  if not lire_config('modem','stop',s) then erreur('Stop non trouv');
  s:=upstring(s);
  stop:=S1;
  while (s2stop[stop]<>s) do begin
    if stop=S2 then erreur('Stop non valide');
    stop:=succ(stop);
  end;
  if not lire_config('modem','controle',s) then erreur('Contrle non trouv');
  s:=upstring(s);
  controle:=No;
  while (s2controle[controle]<>s) do begin
    if controle=xonxoff then erreur('Contrle non valide');
    controle:=succ(controle);
  end;
  {on a rcupr tous les paramtres, on essaie d'ouvrir le port de communication :}
  initcom(com,vitesse,parite,longueur,stop,controle);
  if not comallowed(com) then erreur('Paramtres d''initialisation non valides ou erreur du modem');
  car:=readcom(com);  {on vide le buffer 'de bits' du modem}
end;

procedure affiche;
{affichage de la fenetre entire : menu+bordures+fenetres emission/reception}
{on tient compte des parametres utilisateur (champs de 'user')}
{assez lent : usage de crt...}
var i:byte;
begin
  {on efface tout...}
  window(1,1,80,25);

  {barres de menus}
  textcolor(user.t_menu);
  textbackground(user.b_menu);
  gotoxy(1,1);
  write(' F1:Aide  F2:Connecter  F3:Dcrocher  F4:Racrocher  F5:Alias           F9:Login ');
  gotoxy(1,25);
  clreol;
  write(' ',user.nom);
  gotoxy(20,25);
  if connecte then write('Connect':20) else write('Non connect':20);
  write(date_heure:40);

  {bordures de zones}
  textcolor(user.t_bordure);
  textbackground(user.b_bordure);
  for i:=3 to 23 do begin
    gotoxy(1,i); write('');
    gotoxy(80,i); write('');
  end;
  gotoxy(1,2);
  write('ͻ');
  gotoxy(1,13);
  write('͹');
  gotoxy(1,24);
  write('ͼ');

  {fond des fentres}
  window(2,3,79,12);
  textbackground(haut^.cback);
  clrscr;
  window(2,14,79,23);
  textbackground(bas^.cback);
  clrscr;

  {titre des fentres, avec centrage}
  window(1,1,80,25);
  textbackground(user.b_titre_emission);
  textcolor(user.t_titre_emission);
  gotoxy(40-length(user.titre_emission) div 2,2);
  write(user.titre_emission);
  textbackground(user.b_titre_reception);
  textcolor(user.t_titre_reception);
  gotoxy(40-length(user.titre_reception) div 2,13);
  write(user.titre_reception);
end;

procedure affiche_fenetre(fenetre:Pfenetre);
{affiche le contenu (->buffer) d'une fentre (emission/reception)}
{on affiche toutes les lignes du buffer visibles, allant de la position de}
{scrolling 'fenetre^.ligne' jusqu' la fin de la fentre ou de la position}
{du curseur 'fenetre^.ycurs'}
var l:byte;
begin
  with fenetre^ do begin
    window(x1,y1,x2,y2);
    textbackground(cback);
    textcolor(ctext);
    l:=ligne;
    {on affiche ce qui est ncessaire}
    while (l<=ligne+9) and (l<=y_curs) do begin
      gotoxy(1,l-ligne+1);
      write(buffer[l]);
      clreol;
      inc(l);
    end;
    {on efface les lignes ventuellement scrolles}
    while (l<=ligne+9) do begin
      gotoxy(1,l-ligne+1);
      clreol;
      inc(l);
    end;
    gotoxy(x_curs,y_curs-ligne+1); {re-positionnement du curseur}
  end;
end;

function pas_at_devant(x:byte; s:string):boolean;
{renvoie true si la chane prcdant s[x] n'est pas une commande AT dont}
{il faut tenir compte. i.e : si on est connect ou si on est au del de AT}
var pos_at:byte;

  function min_pas_0(a,b:byte):byte;
  {retourne le min(a,b) sauf 0 si possible -> recherche de la premire}
  {commande at de la chaine}
  begin
    if a=0 then min_pas_0:=b else
      if b=0 then min_pas_0:=a else
        if a>=b then min_pas_0:=b else min_pas_0:=a;
  end;

begin
  pos_at:=min_pas_0(pos('at',s),pos('AT',s));
  pas_at_devant:=connecte or (pos_at=0) or (x>pos_at+2);
end;

procedure ecrire_fenetre(var fenetre:Pfenetre; c:char);
{ajout d'un caractre 'c' dans 'fenetre'}
{on gre les caractres de contrle : backspace, entre ainsi que le backspace}
{devant une commande AT}

  procedure ligne_suivante;
  {passage  la ligne suivante avec scrolling de buffer si dpassement}
  var i:word;
  begin
    with fenetre^ do begin
      x_curs:=1;
      inc(y_curs);
      {si on arrive  la fin du buffer, on dcale toutes les lignes}
      if y_curs>MAX_LIGNES then begin
        for i:=1 to MAX_LIGNES-1 do buffer[i]:=buffer[i+1];
        buffer[MAX_LIGNES]:='';
        dec(y_curs);
      end;
    end;
  end;

begin
  with fenetre^ do begin
    case c of
       {backspace}
       #8:if (x_curs<>1) or (y_curs<>1) then begin
            {bord de ligne -> ligne prcedent}
            if (x_curs=1) then
              if pas_at_devant(length(buffer[y_curs-1])+1,buffer[y_curs-1]) then begin
                dec(y_curs);
                delete(buffer[y_curs],length(buffer[y_curs]),1);
                x_curs:=length(buffer[y_curs])+1;
              end else
            {cas normal, curseur dans la ligne}
            else if pas_at_devant(x_curs,buffer[y_curs]) then begin
              delete(buffer[y_curs],length(buffer[y_curs]),1);
              dec(x_curs);
            end;
          end;
      {entre}
      #13:ligne_suivante;
      {entr}
      #10:;{on supprime ce caractre qui suit le #13 (entre format DOS)}
      {autres caractres}
      else begin
        buffer[y_curs]:=buffer[y_curs]+c;
        if x_curs<78 then inc(x_curs)
        else ligne_suivante;
      end;
    end;
  end;
  {on replace la focalisation (scrolling) sur le caractre tap}
  {dans le cas ou on ne le verrait pas => on voit toujours ce qui part/arrive}
  {la fenetre fait 10 lignes de hauteur}
  with fenetre^ do
    if (y_curs>=ligne+10) or (y_curs<ligne) then
      if y_curs<=10 then ligne:=1
      else ligne:=y_curs-9;

  affiche_fenetre(fenetre);
end;

procedure lire_modem;
{reoit des caractres du modem et les envoie sur la fenetre de reception}
var c:char;
begin
  {la boucle 'while' permet une rception de caractres contigus}
  while comreceived(com) do begin
    c:=readcom(com);
    ecrire_fenetre(bas,c);
  end;
end;

procedure ecrire_modem(c:char);
{envoie le caractre 'c' au modem, ds que possible}
begin
  repeat until comallowed(com);
  writecom(com,c);
end;

procedure ecrire_modem_str(s:string);
{envoie la chaine 's'+#13 (entre) au modem}
{en vrifiant l'arrive de caractres, pour ne rien perdre}
var i:byte;
begin
  for i:=1 to length(s) do begin
    ecrire_modem(s[i]);
    lire_modem;
  end;
  ecrire_modem(#13);  {validation de la commande}
  lire_modem;
end;

procedure charge_user(logi:string);
{charge les paramtres utilisateurs contenus dans le fichier de configuration}
{on cherche la section 'logi', qui doit contenir les paramtres  modifier}
{lorsque un paramtre n'est pas mentionn dans la section, il n'est pas modifi}
var temp:string;
    ok:boolean;
begin
  login:=logi;
  ok:=lire_config(login,'nom',user.nom);
  ok:=lire_config_num(login,'t_menu',user.t_menu);
  ok:=lire_config_num(login,'b_menu',user.b_menu);
  ok:=lire_config_num(login,'t_bordure',user.t_bordure);
  ok:=lire_config_num(login,'b_bordure',user.b_bordure);
  ok:=lire_config_num(login,'t_emission',haut^.ctext);
  ok:=lire_config_num(login,'b_emission',haut^.cback);
  ok:=lire_config_num(login,'t_reception',bas^.ctext);
  ok:=lire_config_num(login,'b_reception',bas^.cback);
  ok:=lire_config_num(login,'t_titre_emission',user.t_titre_emission);
  ok:=lire_config_num(login,'b_titre_emission',user.b_titre_emission);
  ok:=lire_config_num(login,'t_titre_reception',user.t_titre_reception);
  ok:=lire_config_num(login,'b_titre_reception',user.b_titre_reception);
  ok:=lire_config_num(login,'t_popup',user.t_popup);
  ok:=lire_config_num(login,'b_popup',user.b_popup);
  ok:=lire_config(login,'titre_emission',user.titre_emission);
  ok:=lire_config(login,'titre_reception',user.titre_reception);
  ok:=lire_config(login,'init',temp);
  if ok then ecrire_modem_str(temp);   {initialisation du modem personalise}
end;

procedure init;
{initialise le programme, ses variables globales, les pointeurs (buffers), }
{et le matriel (modem, heure) }
{c'est l'utilisateur 'defaut' qui est charg, qui donne les paramtres}
{d'apparance et d'initialisation du modem (commandes AT) par dfaut}
var i:word;
begin
  new(haut);            {rservation de mmoire}
  new(bas);

  init_modem;           {initialisation du modem}
  quitte:=false;
  connecte:=false;

  {Iniialisation des fentres, vidage du buffer}
  with haut^ do begin
    for i:=1 to MAX_BUFFER do
      buffer[i]:='';
    ligne:=1;
    x_curs:=1;
    y_curs:=1;
    x1:=2;
    x2:=79;
    y1:=3;
    y2:=12;
  end;
  with bas^ do begin
    for i:=1 to MAX_BUFFER do
      buffer[i]:='';
    ligne:=1;
    x_curs:=1;
    y_curs:=1;
    x1:=2;
    x2:=79;
    y1:=14;
    y2:=23;
  end;
  temps:=date_heure;
  charge_user('defaut');
  affiche;                 {on affiche tout l'cran lorsque tout est prt}
end;

procedure lire_user;
{Si l'utilisateur tappe au clavier, rcupre le code ascii de la touche}
{puis spare les touches de commande (F1-F9, page up/down...) des caractres}
{ mettre sur le modem}
var c:word;
    s:string;
begin
  if keypressed then begin
    c:=ntouche;   {code ascii / +1000 si tendu}
    if (c<1000) and (c<>27) then begin   {caractre normal -> modem}
      ecrire_modem(chr(c));
      ecrire_fenetre(haut,chr(c));
    end else begin                       {caractre tendu -> fonction}
      case c of
          {ESC}
          27:quitte:=popup_confirm('QUITTER');
          {dbut scroll}
        1071:if haut^.ligne>1 then dec(haut^.ligne);
          {fin scroll}
        1079:if haut^.ligne<haut^.y_curs then inc(haut^.ligne);
          {page up scroll}
        1073:if bas^.ligne>1 then dec(bas^.ligne);
          {page down scroll}
        1081:if bas^.ligne<bas^.y_curs then inc(bas^.ligne);

          {F1-F9}
          {aide}
        1059:popup_aide;
          {connection via popup}
        1060:if popup_param('CONNECTER','Numro  composer :',s) then begin
                 ecrire_modem_str('atd'+s);
                 connecte:=true;
               end;
          {dcroche appel entrant}
        1061:begin ecrire_modem_str('ata'); connecte:=true; end;
          {racroche}
        1062:if popup_confirm('RACROCHER') then begin
               breakcom(com);
               ecrire_modem_str('ath');
               connecte:=false;
             end;
          {alias utilisateur}
        1063:if popup_param('ALIAS','Entrez un alias :',s) then
               if lire_config(login,s,s) then ecrire_modem_str(s);
          {changement utilisateur}
        1067:if popup_param('LOGIN','Entrez votre login :',s) then charge_user(s);
      end;
      {actualisation de l'cran}
      affiche;
      affiche_fenetre(bas);
      affiche_fenetre(haut);
    end;
  end;
end;

{programme principal}
begin
  {initialisation var+matriel}
  init;
  repeat
    {actualisation de l'heure si ncessaire}
    if temps<>date_heure then begin
      temps:=date_heure;
      window(61,25,80,25);
      textbackground(user.b_menu);
      textcolor(user.t_menu);
      write(date_heure);
      affiche_fenetre(haut); {pour replacer le curseur ds la fentre d'mission}
    end;
    {lecture modem/utilisateur en polling}
    lire_modem;
    lire_user;
  until quitte;
  {d-allocation mmoire/matriel restauration cran}
  close;
end.
